// MQGet.cpp : Implementation file for MQSI V2.0.1 plug-in node
//
// Template built by MQSI V2 Visual Studio Wizard (kolban@us.ibm.com)
//
// Installation:
// For NT:		<MQSI Root>\bin
// For Unix:	<MQSI Root>/lil
//
#ifdef _WIN32
#include "stdafx.h"
#endif
#include <stdarg.h>		// Required for variable length arguments
#include <stdio.h>		// Required for file IO and NULL declaration
#include <stdlib.h>		// Required for memory manipulation
#include <BipCci.h>		// Common functions (between nodes and parsers)
#include <BipCni.h>		// Message processing nodes
#include <cmqc.h>
#ifdef _WIN32
#include "NT_msg/mqget_msg.h"
#endif

#ifdef _AIX
#include "AIX_msg/MQGET_msg.h"
#endif

#ifdef _SOLARIS
#include "SOLARIS_msg/msg.h"
#endif

#include "NodeUtils.h"	// Include the required utility functions

CciChar *c_inputQueueName;
CciChar *c_msgPath;
CciChar *c_dataType;
CciChar *c_selectByMsgId;
CciChar *c_selectByCorrelId;
CciChar *c_transactionMode;
CciChar *c_none;
CciChar *c_true;
CciChar *c_false;
CciChar *c_Automatic;
CciChar *c_in;
CciChar *c_out;
CciChar *c_failure;
CciChar *c_no_message;
CciChar *c_label;
CciChar *c_String;
CciChar *c_Yes;
CciChar *c_MQSIV2_MQGET;
CciChar *c_MQGetFactory;
CciChar *c_MQGetNode;

void InitConstants()
{
	c_inputQueueName	= mqsixASCIIToUnicode("inputQueueName");
	c_msgPath			= mqsixASCIIToUnicode("msgPath");
	c_dataType			= mqsixASCIIToUnicode("dataType");
	c_selectByMsgId		= mqsixASCIIToUnicode("selectByMsgId");
	c_selectByCorrelId	= mqsixASCIIToUnicode("selectByCorrelId");
	c_transactionMode	= mqsixASCIIToUnicode("transactionMode");
	c_none				= mqsixASCIIToUnicode("none");
	c_true				= mqsixASCIIToUnicode("true");
	c_false				= mqsixASCIIToUnicode("false");
	c_Automatic			= mqsixASCIIToUnicode("Automatic");
	c_in				= mqsixASCIIToUnicode("in");
	c_out				= mqsixASCIIToUnicode("out");
	c_failure			= mqsixASCIIToUnicode("failure");
	c_no_message		= mqsixASCIIToUnicode("no message");
	c_label				= mqsixASCIIToUnicode("label");
	c_String			= mqsixASCIIToUnicode("String");
	c_Yes				= mqsixASCIIToUnicode("Yes");
	c_MQSIV2_MQGET		= mqsixASCIIToUnicode("MQSIV2_MQGET");
	c_MQGetFactory		= mqsixASCIIToUnicode("MQGetFac");
	c_MQGetNode			= mqsixASCIIToUnicode("MQGetNode");
}

///////////////////////////////////////////////////////////
// NodeContext
struct NodeContext
{
	//MQSIX_ATTRIBUTES	attributes;
	MQSIX_ATTRIBUTES	*attributes;
	CciChar				*label;
	int			initialized;
	MQHCONN		hConn;
	MQHOBJ		hQueue;
	MQCHAR		strInputQueueName[49];
	MQCHAR		strQueueManagerName[49];
	char		strMsgPath[50];
	int			iType;
	int			bSelectByMsgId;
	int			bSelectByCorrelId;
	int			iQueueConnectionPreFormed;
	MQBYTE		*messageBuffer;
	MQLONG		iMessageBufferSize;
	MQLONG		iSyncPoint;
	CciTerminal	*inTerminal;		// In Terminal
	CciTerminal	*outTerminal;		// Out Terminal
	CciTerminal	*failureTerminal;	// Out Terminal
	CciTerminal	*noMessageTerminal;	// Out Terminal
};

#ifdef _WIN32
static HMODULE g_module;

BOOL APIENTRY DllMain(
	HMODULE hModule,
	DWORD  ul_reason_for_call,
	LPVOID lpReserved
					 )
{
	g_module = hModule;
    return TRUE;
}
#endif

///////////////////////////////////////////////////////////
// CreateNodeContext
void *CreateNodeContext(
	CciFactory	*factoryObject,
	CciChar		*nodeName,
	CciNode		*nodeObject)
{
	struct NodeContext	*pMyContext;
	int					iRc;
	char				*strTempA;
	//CNI_BROKER_INFO_ST	brokerInfo;
	MQSIX_NODE_INFO		nodeInfo;


	pMyContext = (struct NodeContext *)malloc(sizeof(struct NodeContext));
	pMyContext->attributes = NULL;
	mqsixAddAttribute(&pMyContext->attributes, c_inputQueueName, c_none);
	mqsixAddAttribute(&pMyContext->attributes, c_msgPath, c_none);
	mqsixAddAttribute(&pMyContext->attributes, c_dataType, c_none);
	mqsixAddAttribute(&pMyContext->attributes, c_selectByMsgId, c_false);
	mqsixAddAttribute(&pMyContext->attributes, c_selectByCorrelId, c_false);
	mqsixAddAttribute(&pMyContext->attributes, c_transactionMode, c_Automatic);

	mqsixLog(">> CreateNodeContext: Node Name=%S\n", nodeName);
	pMyContext->inTerminal = cniCreateInputTerminal(&iRc, nodeObject, c_in);
	pMyContext->outTerminal = cniCreateOutputTerminal(&iRc, nodeObject, c_out);
	pMyContext->failureTerminal = cniCreateOutputTerminal(&iRc, nodeObject, c_failure);
	pMyContext->noMessageTerminal = cniCreateOutputTerminal(&iRc, nodeObject, c_no_message);
	//mqsixInitializeAttributes(&pMyContext->attributes);

	pMyContext->initialized = 0;
	pMyContext->iQueueConnectionPreFormed = 0;
	pMyContext->hConn = 0;
	pMyContext->hQueue = 0;
	pMyContext->iMessageBufferSize = 4096;			// Initial buffer size = 4K
	pMyContext->messageBuffer = (MQBYTE *)malloc(pMyContext->iMessageBufferSize + 1);
	pMyContext->bSelectByCorrelId = 0;
	pMyContext->bSelectByMsgId = 0;

	mqsixBrokerInfo(nodeObject, &nodeInfo);
	strTempA = mqsixUnicodeToASCII(nodeInfo.queueManagerName);
	strcpy(pMyContext->strQueueManagerName, strTempA);
	free(strTempA);

	/*
	brokerInfo.brokerName.buffer = (CciChar *)malloc(sizeof(CciChar) * 100);
	brokerInfo.brokerName.bufferLength = 100;
	brokerInfo.executionGroupName.buffer = (CciChar *)malloc(sizeof(CciChar) * 100);
	brokerInfo.executionGroupName.bufferLength = 100;
	brokerInfo.messageFlowName.buffer = (CciChar *)malloc(sizeof(CciChar) * 100);
	brokerInfo.messageFlowName.bufferLength = 100;
	brokerInfo.queueManagerName.buffer = (CciChar *)malloc(sizeof(CciChar) * 100);
	brokerInfo.queueManagerName.bufferLength = 100;
	cniGetBrokerInfo(&iRc, nodeObject, &brokerInfo);
	strTempA = mqsixUnicodeToASCII(brokerInfo.queueManagerName.buffer);
	strcpy(pMyContext->strQueueManagerName, strTempA);
	free(strTempA);
	free(brokerInfo.brokerName.buffer);
	free(brokerInfo.executionGroupName.buffer);
	free(brokerInfo.messageFlowName.buffer);
	free(brokerInfo.queueManagerName.buffer);
	*/

	return(pMyContext);
}

///////////////////////////////////////////////////////////
// DeleteNodeContext
void DeleteNodeContext(CciContext *context)
{
	struct NodeContext	*pMyContext;
	MQLONG	iCompCode;
	MQLONG	iReason;

	pMyContext = (struct NodeContext *)context;
	mqsixLog(">> DeleteNodeContext\n");
	mqsixReleaseAttributes(pMyContext->attributes);
	// We must release all context entries that were explicitly allocated.

	if (pMyContext->hQueue != 0)
	{
		MQCLOSE(pMyContext->hConn, &pMyContext->hQueue, MQCO_NONE, &iCompCode, &iReason);
		pMyContext->hQueue = 0;
	}

	if (pMyContext->hConn != 0 && !pMyContext->iQueueConnectionPreFormed)
	{
		MQDISC(&pMyContext->hConn, &iCompCode, &iReason);
		pMyContext->hConn = 0;
	}

	if (pMyContext->messageBuffer != NULL)
	{
		free(pMyContext->messageBuffer);
		pMyContext->messageBuffer = NULL;
	}
	free(context);

}

///////////////////////////////////////////////////////////
// GetAttributeName
int GetAttributeName(
	CciContext	*context,
	int			index,
	CciChar		*buffer,
	int			bufsize)
{
	int	iRc;
	struct NodeContext	*pMyContext;

	pMyContext = (struct NodeContext *)context;
	iRc = mqsixGetAttributeName(
		pMyContext->attributes,
		index,
		buffer,
		bufsize);
	return(iRc);
}

///////////////////////////////////////////////////////////
// GetAttribute
int GetAttribute(
	CciContext	*context,
	CciChar		*attrName,
	CciChar		*buffer,
	int bufsize)
{
	struct NodeContext	*pMyContext;
	int					iRc;

	pMyContext = (struct NodeContext *)context;
	iRc = mqsixGetAttribute(
		pMyContext->attributes,
		attrName,
		buffer,
		bufsize);
	return(iRc);
} 

///////////////////////////////////////////////////////////
// SetAttribute
int SetAttribute(
	CciContext	*context,
	CciChar		*attrName,
	CciChar		*attrValue)
{
	struct NodeContext	*pMyContext;
	int					iRc;
	char				*strTempA;

	mqsixLog(">> SetAttribute %S=%S\n", attrName, attrValue);
	pMyContext = (struct NodeContext *)context;
	if (mqsixStringCompare(attrName, c_label) == 0)
	{
		pMyContext->label = mqsixStringDuplicate(attrValue);
		return(1);
	}
	iRc = mqsixSetAttribute(pMyContext->attributes,
		attrName,
		attrValue);

	// Map "dataType"
	// This field is the representation of a message obtained from the queue
	// and how it should be inserted into the message tree.  The choices are:
	// o String
	// o BLOB
	if (mqsixStringCompare(attrName, c_dataType) == 0)
	{
		if (mqsixStringCompare(attrValue, c_String) == 0)
		{
			pMyContext->iType = CCI_VALUE_TYPE_CHAR;
			mqsixLog("Setting message output type to 'String'\n");
		}
		else
		{
			pMyContext->iType = CCI_VALUE_TYPE_BYTEARRAY;
			mqsixLog("Setting message output type to 'BLOB'\n");
		}
	}

	// Map "inputQueueName"
	if (mqsixStringCompare(attrName, c_inputQueueName) == 0)
	{
		strTempA = mqsixUnicodeToASCII(attrValue);
		strncpy(pMyContext->strInputQueueName, strTempA, 48);
		pMyContext->strInputQueueName[48] = '\0';
		free(strTempA);
	}

	// Map "msgPath"
	if (mqsixStringCompare(attrName, c_msgPath) == 0)
	{
		strTempA = mqsixUnicodeToASCII(attrValue);
		strcpy(pMyContext->strMsgPath, strTempA);
		free(strTempA);
	}

	// Map "selectByMsgId"
	if (mqsixStringCompare(attrName, c_selectByMsgId) == 0)
	{
		if (mqsixStringCompare(attrValue, c_true) == 0)
		{
			pMyContext->bSelectByMsgId = 1;
		}
		else
		{
			pMyContext->bSelectByMsgId = 0;
		}
	}
	// Map "selectByCorrelId"
	if (mqsixStringCompare(attrName, c_selectByCorrelId) == 0)
	{
		if (mqsixStringCompare(attrValue, c_true) == 0)
		{
			pMyContext->bSelectByCorrelId = 1;
		}
		else
		{
			pMyContext->bSelectByCorrelId = 0;
		}
	}
	// Map "transactionMode" - values "Automatic", "Yes", "No"
	if (mqsixStringCompare(attrName, c_transactionMode) == 0)
	{
		if (mqsixStringCompare(attrValue, c_Automatic) == 0)
		{
			pMyContext->iSyncPoint = MQGMO_SYNCPOINT_IF_PERSISTENT;
		}
		else if (mqsixStringCompare(attrValue, c_Yes) == 0)
		{
			pMyContext->iSyncPoint = MQGMO_SYNCPOINT;
		}
		else
		{
			pMyContext->iSyncPoint = MQGMO_NO_SYNCPOINT;
		}
	}
	return(iRc);
}

///////////////////////////////////////////////////////////
// Propagate
void Propagate(CciTerminal *pTerminal,
			   CciMessage *pDestinationList,
			   CciMessage *pExceptionList,
			   CciMessage *pOutMessage)
{
	int	iRc;

	cniPropagate(&iRc, pTerminal, 
		pDestinationList, pExceptionList, pOutMessage);

	mqsixLog("-- Propagated through terminal...\n");
	if (iRc != 0)
	{
		mqsixLog("An exception was reported on return from propogate %d\n", iRc);
		cciRethrowLastException(&iRc);
		return;
	}
}

///////////////////////////////////////////////////////////
// GetMessage
// Get a message from the MQSeries queue.  The result is stored in the context
// buffer previously allocated.  If the size of the buffer is too small, the
// buffer is extended and the message retried.
//
// Return: (int) size of message.  The number of bytes of the new message
// stored in the buffer is returned.
//
static int GetMQMessage(struct NodeContext *pMyContext, MQMD *pMQMD)
{
	MQLONG	iCompCode;
	MQLONG	iReason;
	MQLONG	iLength;
	MQGMO	gmo = {MQGMO_DEFAULT};

	gmo.Options = pMyContext->iSyncPoint | MQGMO_FAIL_IF_QUIESCING;
	MQGET(pMyContext->hConn,	// Handle to the queue manager
		pMyContext->hQueue,		// Handle to the queue open for input
		pMQMD,					// MQMD parameter
		&gmo,					// MQGMO paramater
		pMyContext->iMessageBufferSize, pMyContext->messageBuffer, &iLength,
		&iCompCode, &iReason);
	switch(iReason)
	{
	case 0:
		return(iLength);
	case MQRC_TRUNCATED_MSG_FAILED:
		free(pMyContext->messageBuffer);
		pMyContext->messageBuffer = (MQBYTE *)malloc(iLength + 1);
		pMyContext->iMessageBufferSize = iLength;
		return(GetMQMessage(pMyContext, pMQMD));
	default:
		mqsixLog("Failed to get message: %d\n", iReason);
	}
	return(0);

}

///////////////////////////////////////////////////////////
// Evaluate
void Evaluate(
	CciContext	*context, 
	CciMessage	*pDestinationList,
	CciMessage	*pExceptionList,
	CciMessage	*pMessage)
{
	int					iRc;
	struct NodeContext	*pMyContext;
	MQLONG				iCompCode;
	MQLONG				iReason;
	MQLONG				iBufferLength;
	MQLONG				iLength;
	CciElement			*pElement;
	CciElement			*pInputRoot, *pOutputRoot;
	CciMessage			*pOutMessage;
	int					iType=CCI_VALUE_TYPE_CHAR;
	CciChar				*tempChar;
	struct CciByteArray	msgIdByteArray;
	struct CciByteArray	correlIdByteArray;
	int					i;

	char				tempStr[100];

	MQOD				od = {MQOD_DEFAULT};
	MQMD				md = {MQMD_DEFAULT};
	struct CciByteArray	byteArrayValue;

	mqsixDebugBreak();
	mqsixLog(">> Evaluate\n");

	pMyContext = (struct NodeContext *)context;

	pInputRoot = cniRootElement(&iRc, pMessage);
	//mqsixLog("Current thread id: %d\n", GetCurrentThreadId());


	// If we are not connected to a queue manager, connect to the queue
	// manager now.
	if (pMyContext->hConn == 0)
	{
		mqsixLog("Opening queue manager: %s\n", pMyContext->strQueueManagerName);
		MQCONN(pMyContext->strQueueManagerName,
			&pMyContext->hConn,
			&iCompCode, &iReason);
		if (iReason == MQRC_ALREADY_CONNECTED)
		{
			pMyContext->iQueueConnectionPreFormed = 1;
		}
	// If we failed to connect to the queue manager, log an error and then
	// fail the message flow
		if (iReason != 0 && iReason != MQRC_ALREADY_CONNECTED)
		{
			mqsixLog("Failed to open queue manager: %d\n", iReason);
			sprintf(tempStr, "%d", iReason);
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate",
				c_MQSIV2_MQGET, MSG_QUEUEMGR_CONN_FAIL,
				"Failed to connect to queue manager",
				pMyContext->strQueueManagerName, tempStr, (char *)0);
			Propagate(pMyContext->failureTerminal,
				pDestinationList,
				pExceptionList,
				pMessage);
			return;
		}
	}
	if (pMyContext->hQueue == 0)
	{
		mqsixLog("QueueName: %s\n", pMyContext->strInputQueueName);
		strncpy(od.ObjectName, pMyContext->strInputQueueName, 48);

		MQOPEN(pMyContext->hConn, &od, MQOO_INPUT_AS_Q_DEF, &pMyContext->hQueue,
			&iCompCode, &iReason);
		// If we failed to open the queue, log an error message and fail the flow
		if (iReason != 0)
		{
			mqsixLog("Failed to open queue: %d\n", iReason);
			sprintf(tempStr, "%d", iReason);
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate",
				c_MQSIV2_MQGET, MSG_QUEUE_OPEN_FAIL,
				"Failed to open queue",
				pMyContext->strInputQueueName, tempStr, (char *)0);
			Propagate(pMyContext->failureTerminal,
				pDestinationList,
				pExceptionList,
				pMessage);
			return;
		}
	}

	mqsixLog(">> About to get message!\n");
	iBufferLength = 1000;
	// Set the MsgId if needed based upon the flag in the parameters
	// If left alone, MQGET will get the first message on the queue.
	if (pMyContext->bSelectByMsgId)
	{
		mqsixLog("Getting message by messageid!\n");
		// Get the Root.MQMD.MsgId byteArray value ...
		// Copy the lesser of MAXIMUM size vs Size of the byte array ...
		// to the MQMD for the get.
		pElement = mqsixFindElement("Root.MQMD.MsgId", pInputRoot);

		// Oh Oh !!! No Root.MQMD.MsgId field ... that's odd!!!
		if (pElement == NULL)
		{
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate",c_MQSIV2_MQGET,
				MSG_NO_MSGID_TO_MATCH,
				"No MsgId to match",
				(char *)0);
			Propagate(pMyContext->failureTerminal,
				pDestinationList,
				pExceptionList,
				pMessage);
			return;
		}
		mqsixElementByteArrayValue(pElement, &msgIdByteArray);
		iLength = MQ_MSG_ID_LENGTH;
		if (msgIdByteArray.size < iLength)
		{
			iLength = msgIdByteArray.size;
		}
		memcpy(md.MsgId, msgIdByteArray.pointer, iLength);
		free(msgIdByteArray.pointer);
		for (i=0; i<MQ_MSG_ID_LENGTH; i++)
		{
			if (md.MsgId[i] != 0)
			{
				break;
			}
		}
		if (i >= MQ_MSG_ID_LENGTH)
		{
			// Error ... attempt to match on NULL MsgId
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate", c_MQSIV2_MQGET,
				MSG_NULL_MATCH_MSGID,
				"MsgID for match is NULL",
				(char *)0);
		}
	}

	// Set the CorrelIdId if needed based upon the flag in the parameters
	// If left alone, MQGET will get the first message on the queue.
	if (pMyContext->bSelectByCorrelId)
	{
		mqsixLog("Getting message by CorrelId!\n");
		// Get the Root.MQMD.CorrelId byteArray value ...
		// Copy the lesser of MAXIMUM size vs Size of the byte array ...
		// to the MQMD for the get.
		pElement = mqsixFindElement("Root.MQMD.CorrelId", pInputRoot);

		// Oh Oh !!! No Root.MQMD.CorrelId field ... that's odd!!!
		if (pElement == NULL)
		{
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate",
				c_MQSIV2_MQGET, MSG_NO_CORRELID_TO_MATCH,
				"No CorrelId to match",
				(char *)0);
			Propagate(pMyContext->failureTerminal,
				pDestinationList,
				pExceptionList,
				pMessage);
			return;
		}
		mqsixElementByteArrayValue(pElement, &correlIdByteArray);
		iLength = MQ_MSG_ID_LENGTH;
		if (msgIdByteArray.size < iLength)
		{
			iLength = correlIdByteArray.size;
		}
		memcpy(md.CorrelId, correlIdByteArray.pointer, iLength);
		free(correlIdByteArray.pointer);
		for (i=0; i<MQ_CORREL_ID_LENGTH; i++)
		{
			if (md.CorrelId[i] != 0)
			{
				break;
			}
		}
		if (i >= MQ_CORREL_ID_LENGTH)
		{
			// Error ... attempt to match on NULL MsgId
			cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate", c_MQSIV2_MQGET,
				MSG_NULL_MATCH_CORRELID,
				"CorrelID for match is NULL",
				(char *)0);
		}
	}

	// Get the message from the queue
	iLength = GetMQMessage(pMyContext, &md);

	// If we failed to get a message, propagate the flow through the no
	// message terminal.
	if (iLength == 0)
	{
		Propagate(pMyContext->noMessageTerminal,
			pDestinationList,
			pExceptionList,
			pMessage);
		return;
	}

	// We are now in a position to build a complete new message tree.
	// We do this by creating a new message and then copying the incoming
	// message to the out going (new) message.  Once this has been done, we
	// can insert the new element into the tree.

	// After we create the message, we MUST release before ending ...
	pOutMessage = cniCreateMessage(&iRc, cniGetMessageContext(&iRc, pMessage));
	pOutputRoot = cniRootElement(&iRc, pOutMessage);
	cniCopyElementTree(&iRc, pInputRoot, pOutputRoot);

	// Allocate a new element in the message tree
	mqsixLog("Setting message element from MQMessage!\n");
	mqsixDebugBreak();
	pElement = mqsixNewElement(pMyContext->strMsgPath, pOutMessage);
	if (pElement == 0)
	{
		cniDeleteMessage(&iRc, pOutMessage);
		cciLog(&iRc, CCI_LOG_ERROR, __FILE__, __LINE__, "Evaluate",
			c_MQSIV2_MQGET, MSG_BAD_PATH,
			"Bad path for data insert",
			pMyContext->strMsgPath, (char *)0);
		Propagate(pMyContext->failureTerminal,
			pDestinationList,
			pExceptionList,
			pMessage);
		return;
	}
	// The mqsixNewElement may return a node of type NAME only.  Set the type
	// to NAME/VALUE
	cniSetElementType(&iRc, pElement, CCI_ELEMENT_TYPE_NAME_VALUE);

	// At this point we have obtained a message from the MQSeries queue and
	// succesfully created a new out going tree.  What is now left for us to do
	// is insert the MQSeries obtained message into the tree.  The format of the
	// element to be added is supplied as one of the parameters in the context.
	// Based on this convert to String or ByteArray.
	mqsixLog("Message element type: %d\n", pMyContext->iType);
	if (pMyContext->iType == CCI_VALUE_TYPE_CHAR)
	{
		pMyContext->messageBuffer[iLength] = 0;
		tempChar = mqsixASCIIToUnicode((char *)pMyContext->messageBuffer);
		cniSetElementCharacterValue(&iRc, pElement, tempChar, iLength);
		free(tempChar);
	}
	else
	{
		byteArrayValue.pointer = pMyContext->messageBuffer;
		byteArrayValue.size = iLength;
		cniSetElementByteArrayValue(&iRc, pElement, &byteArrayValue);
	}
	
	Propagate(pMyContext->outTerminal, pDestinationList, pExceptionList, pOutMessage);
	cniDeleteMessage(&iRc, pOutMessage);

	mqsixLog("<< Evaluate\n");
	return;
}

///////////////////////////////////////////////////////////
// bipGetMessageflowNodeFactory
// 
// Entry point into the MQGet node.  Called by the broker when
// the node is initially loaded.

#ifdef _WIN32
void __declspec(dllexport) *bipGetMessageflowNodeFactory()
#else
void *bipGetMessageflowNodeFactory()
#endif
{
	static CNI_VFT	virtualFunctionTable;
	int				iRc;
	void			*factoryObject;
#ifdef _WIN32
	mqsixRegisterMessages(g_module, "MQSIV2_MQGET");
#endif

	mqsixLog("\n");
	mqsixLog("************************\n");
	mqsixLog("*** Loading Node LIL ***\n");
	mqsixLog("************************\n");
	InitConstants();

#ifndef _SOLARIS
	mqsixLog(">> Creating nodeFactory: %S, lil build: %s, CCI Version: %d.%d\n",
		c_MQGetFactory, __TIMESTAMP__, CCI_VERSION >> 16, CCI_VERSION & 0xFFFF);
#endif
	memset(&virtualFunctionTable, 0, sizeof(virtualFunctionTable));
	virtualFunctionTable.iFpCreateNodeContext	= CreateNodeContext;
	virtualFunctionTable.iFpDeleteNodeContext	= DeleteNodeContext;
	virtualFunctionTable.iFpGetAttributeName	= GetAttributeName;
	virtualFunctionTable.iFpSetAttribute		= SetAttribute;
	virtualFunctionTable.iFpGetAttribute		= GetAttribute;
	virtualFunctionTable.iFpEvaluate			= Evaluate;

	factoryObject = cniCreateNodeFactory(&iRc, c_MQGetFactory);
	if (iRc != 0)
	{
		mqsixLog("Failed to create factory: iRc=%d\n", iRc);
	}
	cniDefineNodeClass(&iRc, factoryObject, c_MQGetNode, &virtualFunctionTable); 
	if (iRc != 0)
	{
		mqsixLog("Failed to create node class: iRc=%d\n", iRc);
	}

	return(factoryObject);
}
